Gecode::Int::Arithmetic::PowPlusDom< VA, VB, Ops > Class Template Reference

Domain consistent positive power propagator. More...

`#include <arithmetic.hh>`

## Public Member Functions

virtual Actor * | copy (Space &home)
| Copy propagator during cloning.
virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)
| Perform propagation.
Public Member Functions inherited from Gecode::MixBinaryPropagator< VA, PC_INT_DOM, VB, PC_INT_DOM >
virtual void | reschedule (Space &home)
| Schedule function.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
virtual | ~Actor (void)
| To avoid warnings.

## Static Public Member Functions

static ExecStatus | post (Home home, VA x0, VB x1, Ops ops)
| Post propagator.
static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Protected Member Functions

| PowPlusDom (Home home, VA x0, VB x1, const Ops &ops)
| Constructor for posting.
| PowPlusDom (Space &home, PowPlusDom< VA, VB, Ops > &p)
| Constructor for cloning p.
Protected Member Functions inherited from Gecode::MixBinaryPropagator< VA, PC_INT_DOM, VB, PC_INT_DOM >
| MixBinaryPropagator (Space &home, MixBinaryPropagator &p)
| Constructor for cloning.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

Ops | ops
| Operations.
Protected Attributes inherited from Gecode::MixBinaryPropagator< VA, PC_INT_DOM, VB, PC_INT_DOM >
VA | x0
| View of type View0.
VB | x1
| View of type View1.

## Detailed Description

template<class VA, class VB, class Ops>
class Gecode::Int::Arithmetic::PowPlusDom< VA, VB, Ops >

Domain consistent positive power propagator.

This propagator is for positive views only.

Definition at line 420 of file arithmetic.hh.

## Constructor & Destructor Documentation

## PowPlusDom() [1/2]

template<class VA, class VB, class Ops>

Gecode::Int::Arithmetic::PowPlusDom< VA, VB, Ops >::PowPlusDom | ( | Home | home,
|  | VA | x0,
|  | VB | x1,
|  | const Ops & | ops )

inline protected

Constructor for posting.

Definition at line 306 of file pow.hpp.

## PowPlusDom() [2/2]

template<class VA, class VB, class Ops>

Gecode::Int::Arithmetic::PowPlusDom< VA, VB, Ops >::PowPlusDom | ( | Space & | home,
|  | PowPlusDom< VA, VB, Ops > & | p )

inline protected

Constructor for cloning p.

Definition at line 325 of file pow.hpp.

## Member Function Documentation

## copy()

template<class VA, class VB, class Ops>

Actor * Gecode::Int::Arithmetic::PowPlusDom< VA, VB, Ops >::copy | ( | Space & | home | ) |

virtual

Copy propagator during cloning.

Implements Gecode::Actor.

Definition at line 331 of file pow.hpp.

## cost()

template<class VA, class VB, class Ops>

PropCost Gecode::Int::Arithmetic::PowPlusDom< VA, VB, Ops >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function.

If a view has been assigned, the cost is low unary. If in stage for bounds propagation, the cost is low binary. Otherwise it is high binary.

Reimplemented from Gecode::MixBinaryPropagator< VA, PC_INT_DOM, VB, PC_INT_DOM >.

Definition at line 337 of file pow.hpp.

## propagate()

template<class VA, class VB, class Ops>

ExecStatus Gecode::Int::Arithmetic::PowPlusDom< VA, VB, Ops >::propagate | ( | Space & | home,
|  | const ModEventDelta & | med )

virtual

Perform propagation.

Implements Gecode::Propagator.

Definition at line 348 of file pow.hpp.

## post()

template<class VA, class VB, class Ops>

ExecStatus Gecode::Int::Arithmetic::PowPlusDom< VA, VB, Ops >::post | ( | Home | home,
|  | VA | x0,
|  | VB | x1,
|  | Ops | ops )

inline static

Post propagator.

Definition at line 312 of file pow.hpp.

## Member Data Documentation

## ops

template<class VA, class VB, class Ops>

Ops Gecode::Int::Arithmetic::PowPlusDom< VA, VB, Ops >::ops

protected

Operations.

Definition at line 425 of file arithmetic.hh.

The documentation for this class was generated from the following files:

- gecode/int/arithmetic.hh
- gecode/int/arithmetic/pow.hpp